[SDOI2010]地精部落 题解
题目地址:ė …
May all the beauty be blessed.
一张纸可以做s个纸飞机,现在有k个人,每个人要做n个纸飞机,而一包纸有p张,他们想买若干包然后把纸分给每个人让他们做纸飞机,求他们应该买多少包纸才能满足条件。
没什么难度,按照题目的意思求即可。答案是
[eq display=”1″] \lceil \frac{\lceil \frac{n}{s} \rceil k}{p} \rceil [/eq]
打CFR的时候看一眼1A的那种题。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cmath>
int k, n, s, p;
int main() {
scanf("%d%d%d%d", &k, &n, &s, &p);
printf("%d", int(ceil(ceil(double(n) / s) * k / p)));
return 0;
}
给你一个n*n的地图,有的格子可能属于一条船,有的不属于。一条船的长度为k,体现在地图上就是横向或者纵向连续的k个是船的格子。求可能属于的船的数量最多的格子。
数据范围:n 100
枚举每个格子,然后暴力找到它可能属于的船的数量。具体来说,就是上下/左右找一通连通块,注意延伸出去不能超过k-1格不然不能把这个格子包含进去。然后答案就是这个连通块的大小减去k-1。
写了一会,由于当时CFR就写的很丑emm
// Code by KSkun, 2018/4
#include <cstdio>
#include <cmath>
#include <algorithm>
int n, k;
char mmp[105][105];
int ax, ay, ans = -1;
inline int count(int x, int y) {
if(mmp[x][y] == '#') return 0;
int cnt = 0, tcnt = 1, bcnt = 0;
for(int i = x - 1; i >= 1; i--) {
if(mmp[i][y] == '#') break;
tcnt++;
}
if(tcnt > k) tcnt = k; cnt += tcnt; tcnt = 1;
for(int i = x + 1; i <= n; i++) {
if(mmp[i][y] == '#') break;
tcnt++;
}
if(tcnt > k) tcnt = k; cnt += tcnt - 1; tcnt = 1;
bcnt += std::max(cnt - (k - 1), 0); cnt = 0;
for(int i = y - 1; i >= 1; i--) {
if(mmp[x][i] == '#') break;
tcnt++;
}
if(tcnt > k) tcnt = k; cnt += tcnt; tcnt = 1;
for(int i = y + 1; i <= n; i++) {
if(mmp[x][i] == '#') break;
tcnt++;
}
if(tcnt > k) tcnt = k; cnt += tcnt - 1; tcnt = 1;
bcnt += std::max(cnt - (k - 1), 0); cnt = 0;
return bcnt;
}
int main() {
scanf("%d%d%d%d", &n, &k);
for(int i = 1; i <= n; i++) {
scanf("%s", mmp[i] + 1);
}
for(int i = 1; i <= n; i++) {
for(int j = 1; j <= n; j++) {
int cnt = count(i, j);
if(cnt > ans) {
ans = cnt; ax = i; ay = j;
}
}
}
printf("%d %d", ax, ay);
return 0;
}
k个人想分n块糖。分糖的规则是这样的,先确定每个人每次分到的糖x,先给第一个人x个,然后第二个,一轮给完以后再轮到第一个人,直到剩下的糖数不足x,剩下的糖会直接扔掉。但是有限制每个人最多不能分到糖D次,且x也不能大于M。求第一个人分到糖的最大数目。
数据范围:n: 1e18,M: ≤n,D: 1e3
我们看到D的范围很小,因此我们可以枚举每个人分到的糖的最多次数i。我们可以根据i计算出一个x的范围,而实际上我们肯定想要最大的x,因为第一个人分到糖的数量实际上是xi。这个x很好求:
x = \lfloor \frac{n}{k(i-1)+1} \rfloor
求出x以后看一下超没超M,超了就直接设成M检查x是否能满足i的要求。然后对于x直接计算答案即可。对于一个确定的x,它的答案是xi。
CFR的时候,一没看见剩下的糖扔掉,二没看见D的范围小,而且对数据范围并不敏感,直接导致没想到枚举D。想到了以后应该是很好做的吧。
当时打了个表,发现如果不管剩下的糖扔掉这条,答案在n的两个因数之间是单峰的,写了个找因数+三分找峰,复杂度O(\sqrt{n} + \log^2 n),直接TLE。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cmath>
#include <algorithm>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
LL n, k, M, D;
int main() {
n = readint(); k = readint(); M = readint(); D = readint();
LL ans = 0;
for(LL i = 1; i <= D; i++) {
LL lg = log(i - 1) / log(10) + log(k) / log(10); // 会爆LL,log处理一下
if(lg > log(n) / log(10)) continue;
LL x = std::min(M, n / ((i - 1) * k + 1));
if(!x) continue;
LL ri = ceil(n / x / double(k));
if(ri != i) continue;
ans = std::max(ans, x * i);
}
printf("%I64d", (long long) ans);
return 0;
}
河宽w,一只青蛙最多能跳l这么远。给你河中每个位置的石头数,每个石头只能用一次,用完了就沉入水中了,求最多能让多少青蛙过河。
数据范围:w, l: 1e5
最开始想了个网络流的模型,拆点限流石头个数,然后从i向[i+1, i+l]中的每个石头连出边,但是这样的边数是O(n^2)的空间开不下。
其实我们来想一下,S的出边到[1, l],而[1, l]的出边到[2, l+1],依次类推,我们可以把这样一个区间内的点合起来看做最大流的限制啊!也就是说,\min_{i=l}^{w-1} \{sum_i - sum_{i-l}\}就是答案。
其实CF官解的解释是这样的:二分答案k,对于确定的k,首先当从近到远第i块石头到第i+k块的距离大于l的时候,k只青蛙是过不去的。因为最左边那只就跳不过去了,所以就可以O(n)验证确定的k。简化这个过程也能得到上面的解法。
// Code by KSkun, 2018/4
#include <cstdio>
#include <algorithm>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
int w, l, a[100005];
int main() {
w = readint(); l = readint();
for(int i = 1; i < w; i++) {
a[i] = readint() + a[i - 1];
}
int ans = 1e9;
for(int i = l; i < w; i++) {
ans = std::min(ans, a[i] - a[i - l]);
}
printf("%d", ans);
return 0;
}
把n个字符串用它的一个前缀不重复地代表,求最小的代表串长度和。
数据范围:字符串总长: 1e5
如果放在Trie树上看这个问题,就是把一些word标记给提到这个节点的某个父亲的位置,且每个节点只能有一个word标记。考虑一个节点的子树内的word标记全都提前过,现在这个节点上本来就有word标记,那么这个节点的子树的提前也已经完成了,而如果没有word标记,就要从子树中选择一个提前,我们显然应该选择子树中深度较大的那个。逐子树递归完成这个操作,每个子树维护一个可并堆,最后把堆里的元素加个和就完事了。
复杂度O(n \log n)。
用了下pb_ds的可并堆,其实好像普通堆O(n \log n)合并也没事?
// Code by KSkun, 2018/4
#include <cstdio>
#include <ext/pb_ds/priority_queue.hpp>
typedef __gnu_pbds::priority_queue<int, std::less<int>,
__gnu_pbds::pairing_heap_tag> priority_queue;
const int MAXN = 100005;
int ch[MAXN][26], tot = 1;
bool wrd[MAXN];
inline void insert(char *s) {
int p = 1;
for(int i = 0; s[i]; i++) {
int c = s[i] - 'a';
if(!ch[p][c]) ch[p][c] = ++tot;
p = ch[p][c];
}
wrd[p] = true;
}
inline void dfs(int u, priority_queue &q, int dep) {
for(int c = 0; c < 26; c++) {
if(ch[u][c]) {
priority_queue p;
dfs(ch[u][c], p, dep + 1);
q.join(p);
}
}
if(!wrd[u]) q.pop();
q.push(dep);
}
int n;
char s[MAXN];
int main() {
scanf("%d", &n);
for(int i = 1; i <= n; i++) {
scanf("%s", s);
insert(s);
}
int ans = 0;
for(int c = 0; c < 26; c++) {
if(ch[1][c]) {
priority_queue q;
dfs(ch[1][c], q, 1);
while(!q.empty()) {
ans += q.top();
q.pop();
}
}
}
printf("%d", ans);
return 0;
}
题目地址:洛谷:【P3227】[HNOI2013]切糕 – 洛谷、BZOJ:Problem 3144. — [Hnoi2013]切糕
经过千辛万苦小 A 得到了一块切糕,切糕的形状是长方体,小 A 打算拦腰将切糕切成两半分给小 B。出于美观考虑,小 A 希望切面能尽量光滑且和谐。于是她找到你,希望你能帮她找出最好的切割方案。
出于简便考虑,我们将切糕视作一个长 P、宽 Q、高 R 的长方体点阵。我们将位于第 z层中第 x 行、第 y 列上(1≤x≤P, 1≤y≤Q, 1≤z≤R)的点称为(x,y,z),它有一个非负的不和谐值 v(x,y,z)。一个合法的切面满足以下两个条件:
输入格式:
第一行是三个正整数P,Q,R,表示切糕的长P、 宽Q、高R。第二行有一个非负整数D,表示光滑性要求。接下来是R个P行Q列的矩阵,第z个 矩阵的第x行第y列是v(x,y,z) (1<=x<=P, 1<=y<=Q, 1<=z<=R)。
100%的数据满足P,Q,R<=40,0<=D<=R,且给出的所有的不和谐值不超过1000。
输出格式:
仅包含一个整数,表示在合法基础上最小的总不和谐值。
输入样例#1:
2 2 2 1 6 1 6 1 2 6 2 6
输出样例#1:
6
最佳切面的f为f(1,1)=f(2,1)=2,f(1,2)=f(2,2)=1
网络流中,表示“选择”含义我们通常使用最小割模型。本题中,我们想从某个纵轴(x, y)的若干点中选取一个,这种情况我们可以采取用点权作为容量的边将点连成一条链,再分别从链头链尾向源汇连不可割(容量无限)的边,这样割去某个边就可以代表选择某个点了。
然后,我们还需要加入限制|f(x,y)-f(x',y')| \leq D。其实就是说,对于每个点,当相邻纵轴选取的点的距离超过D,就得让这种方案无效,即仍然有流可以通过这一部分到达汇,可以通过加边的方法实现。对于任意点 (x, y, z) ,向相邻点 (x', y', z - D) 连容量无限的边,这样就可以满足限制条件了。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cstring>
#include <queue>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF
: *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 100005, INF = 1e9;
struct Edge {
int to, cap, nxt;
} gra[MAXN << 1];
int head[MAXN], tot;
inline void addedge(int u, int v, int cap) {
gra[tot] = Edge {v, cap, head[u]}; head[u] = tot++;
gra[tot] = Edge {u, 0, head[v]}; head[v] = tot++;
}
int level[MAXN];
inline bool bfs(int s, int t) {
memset(level, -1, sizeof(level));
std::queue<int> que;
level[s] = 0; que.push(s);
while(!que.empty()) {
int u = que.front(); que.pop();
for(int i = head[u]; ~i; i = gra[i].nxt) {
int v = gra[i].to;
if(gra[i].cap > 0 && level[v] == -1) {
level[v] = level[u] + 1;
if(v == t) return true;
que.push(v);
}
}
}
return level[t] != -1;
}
int cur[MAXN];
inline int dfs(int u, int t, int left) {
if(u == t || !left) return left;
int flow = 0;
for(int &i = cur[u]; ~i; i = gra[i].nxt) {
int v = gra[i].to;
if(gra[i].cap > 0 && level[v] == level[u] + 1) {
int d = dfs(v, t, std::min(left, gra[i].cap));
if(d > 0) {
flow += d; left -= d;
gra[i].cap -= d; gra[i ^ 1].cap += d;
if(!left) return flow;
}
}
}
return flow;
}
inline int dinic(int s, int t) {
int flow = 0;
while(bfs(s, t)) {
memcpy(cur, head, sizeof(head));
int f;
while(f = dfs(s, t, INF)) {
flow += f;
}
}
return flow;
}
const int fix[2][4] = {{1, -1, 0, 0}, {0, 0, 1, -1}};
int n, m, h, d, v[45][45][45], S, T;
int main() {
memset(head, -1, sizeof(head));
n = readint(); m = readint(); h = readint(); d = readint();
S = n * m * (h + 1) + 1; T = S + 1;
for(int k = 1; k <= h; k++) {
for(int i = 1; i <= n; i++) {
for(int j = 1; j <= m; j++) {
v[i][j][k] = readint();
}
}
}
for(int i = 1; i <= n; i++) {
for(int j = 1; j <= m; j++) {
int p = (i - 1) * m + j;
addedge(S, p, INF);
addedge(h * n * m + p, T, INF);
for(int k = 1; k <= h; k++) {
addedge((k - 1) * n * m + p, k * n * m + p, v[i][j][k]);
}
}
}
for(int i = 1; i <= n; i++) {
for(int j = 1; j <= m; j++) {
for(int t = 0; t < 4; t++) {
int nx = i + fix[0][t], ny = j + fix[1][t];
if(nx < 1 || nx > n || ny < 1 || ny > m) continue;
for(int k = d + 1; k <= h + 1; k++) {
addedge((k - 1) * n * m + (i - 1) * m + j,
(k - d - 1) * n * m + (nx - 1) * m + ny, INF);
}
}
}
}
printf("%d", dinic(S, T));
return 0;
}
题目地址:洛谷:【P4249】[WC2007]剪刀石头布 – 洛谷、BZOJ:Problem 2597. — [Wc2007]剪刀石头布
在一些一对一游戏的比赛(如下棋、乒乓球和羽毛球的单打)中,我们经常会遇到A胜过B,B胜过C而C又胜过A的有趣情况,不妨形象的称之为剪刀石头布情况。有的时候,无聊的人们会津津乐道于统计有多少这样的剪刀石头布情况发生,即有多少对无序三元组(A, B, C),满足其中的一个人在比赛中赢了另一个人,另一个人赢了第三个人而第三个人又胜过了第一个人。注意这里无序的意思是说三元组中元素的顺序并不重要,将(A, B, C)、(A, C, B)、(B, A, C)、(B, C, A)、(C, A, B)和(C, B, A)视为相同的情况。
有N个人参加一场这样的游戏的比赛,赛程规定任意两个人之间都要进行一场比赛:这样总共有场比赛。比赛已经进行了一部分,我们想知道在极端情况下,比赛结束后最多会发生多少剪刀石头布情况。即给出已经发生的比赛结果,而你可以任意安排剩下的比赛的结果,以得到尽量多的剪刀石头布情况。
输入格式:
输入文件的第1行是一个整数N,表示参加比赛的人数。
之后是一个N行N列的数字矩阵:一共N行,每行N列,数字间用空格隔开。
在第(i+1)行的第j列的数字如果是1,则表示i在已经发生的比赛中赢了j;该数字若是0,则表示在已经发生的比赛中i败于j;该数字是2,表示i和j之间的比赛尚未发生。数字矩阵对角线上的数字,即第(i+1)行第i列的数字都是0,它们仅仅是占位符号,没有任何意义。
输入文件保证合法,不会发生矛盾,当i≠j时,第(i+1)行第j列和第(j+1)行第i列的两个数字要么都是2,要么一个是0一个是1。
输出格式:
输出文件的第1行是一个整数,表示在你安排的比赛结果中,出现了多少剪刀石头布情况。
输出文件的第2行开始有一个和输入文件中格式相同的N行N列的数字矩阵。第(i+1)行第j个数字描述了i和j之间的比赛结果,1表示i赢了j,0表示i负于j,与输入矩阵不同的是,在这个矩阵中没有表示比赛尚未进行的数字2;对角线上的数字都是0。输出矩阵要保证合法,不能发生矛盾。
输入样例#1:
3 0 1 2 0 0 2 2 2 0
输出样例#1:
1 0 1 0 0 0 1 1 0 0
【评分标准】
对于每个测试点,仅当你的程序的输出第一行的数字和标准答案一致,且给出了一个与之一致的合法方案,你才能得到该测试点的满分,否则该测试点得0分。
【数据范围】
30%的数据中,N≤6;
100%的数据中,N≤100。
考虑一下这样的三元组的相关性质,比如:1.这是个三元环,好像没用。2.三元组构成的子图中,所有点的入度/出度都是1,好像也没用。正难则反,我们考虑一下不符合条件的三元组,则子图中存在点的入度为2,也存在点的入度为0,出度也有类似性质。我们不妨考虑入度,假如点i的入度为d_i,则不合法的三元组个数是\sum_{i=1}^n \mathrm{C}_{d_i}^2,这是因为任意选择两个有出边连向i的点与i组成三元组都是不合法的,而且由于是有向图,这个统计并不会重复。现在我们有办法求出不合法的三元组个数了,用总三元组数减去它就是合法的三元组数了,即答案是
\mathrm{C}_n^3 - \sum_{i=1}^n \mathrm{C}_{d_i}^2
其中
\mathrm{C}_n^3 = \frac{n(n-1)(n-2)}{6}
我们考虑一条不确定的边对它所连接的两个点的入度造成的影响,以及对答案造成的影响。实际上一条不确定的边会导致它连接的两个点其中一个点的入度+1,而我们知道有
\mathrm{C}_n^2 - \mathrm{C}_{n-1}^2 = n-1
这就是一个费用递增的模型!我们可以建立源→不确定的边→原图中的点→汇的网络。其中源→不确定的边→原图中的点的所有边为容量1费用0的边,表示选择一种方案。而用原图中的点→汇的边来表示费用递增,即设置为容量1费用从确定的入度到入度上限的一系列边,每一条边表示入度+1对答案的贡献。在这个网络中跑最小费用最大流即可。
对于输出方案,我们检查不确定的边在网络中的对应点的出边,看流流向了哪边,就可以确定该边在方案中的方向。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cstring>
#include <queue>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF
: *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 100005, INF = 1e9;
struct Edge {
int to, cap, cost, nxt;
} gra[MAXN << 1];
int head[MAXN], tot;
inline void addedge(int u, int v, int cap, int cost) {
gra[tot] = Edge {v, cap, cost, head[u]}; head[u] = tot++;
gra[tot] = Edge {u, 0, -cost, head[v]}; head[v] = tot++;
}
int f[MAXN], dis[MAXN], pre[MAXN], pree[MAXN];
std::queue<int> que;
bool inque[MAXN];
inline bool spfa(int s, int t) {
memset(f, 0, sizeof(f));
memset(dis, 0x3f, sizeof(dis));
dis[s] = 0; inque[s] = true; f[s] = INF; que.push(s);
while(!que.empty()) {
int u = que.front(); que.pop(); inque[u] = false;
for(int i = head[u]; ~i; i = gra[i].nxt) {
int v = gra[i].to;
if(gra[i].cap > 0 && dis[v] > dis[u] + gra[i].cost) {
pre[v] = u; pree[v] = i;
f[v] = std::min(f[u], gra[i].cap);
dis[v] = dis[u] + gra[i].cost;
if(!inque[v]) {
inque[v] = true;
que.push(v);
}
}
}
}
return f[t];
}
int flow, cost;
inline void mcmf(int s, int t) {
while(spfa(s, t)) {
for(int i = t; i != s; i = pre[i]) {
gra[pree[i]].cap -= f[t];
gra[pree[i] ^ 1].cap += f[t];
}
flow += f[t];
cost += f[t] * dis[t];
}
}
int n, m, mmp[105][105], deg[105], S, T;
// 1 ~ n point
// n+1 ~ edge
int main() {
memset(head, -1, sizeof(head));
m = n = readint();
S = n * n + 1; T = S + 1;
for(int i = 1; i <= n; i++) {
for(int j = 1; j <= n; j++) {
mmp[i][j] = readint();
if(mmp[i][j] == 2 && i < j) {
addedge(S, ++m, 1, 0);
addedge(m, i, 1, 0);
addedge(m, j, 1, 0);
} else if(mmp[i][j] == 1) {
deg[j]++;
}
}
}
for(int i = 1; i <= n; i++) {
cost += deg[i] * (deg[i] - 1) / 2;
for(int j = deg[i]; j < n - 1; j++) {
addedge(i, T, 1, j);
}
}
mcmf(S, T);
printf("%d\n", n * (n - 1) * (n - 2) / 6 - cost);
m = n;
for(int i = 1; i <= n; i++) {
for(int j = 1; j <= n; j++) {
if(mmp[i][j] == 2) {
int to;
for(int k = head[++m]; ~k; k = gra[k].nxt) {
if(gra[k].cap == 0) {
to = gra[k].to;
break;
}
}
if(to == j) {
mmp[i][j] = 1; mmp[j][i] = 0;
} else if(to == i) {
mmp[j][i] = 1; mmp[i][j] = 0;
}
}
printf("%d ", mmp[i][j]);
}
puts("");
}
return 0;
}